// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "UObject/NoExportTypes.h"
#include "PXConnectNwManager.h"
#include "PXConnectRootObjects.h"
#include "PXConnectMain.generated.h"

/**
 * 
 */
UCLASS()
class PIXERA_CONNECT_API UPXConnectMain : public UObject
{
	GENERATED_BODY()
	
public:
	void pluginStarting(UWorld* pWorld);
	void pluginShuttingDown();
	UPXConnectRootObjects* getRootObjects();
	void worldDestroyed();
	UPXConnectNwManager* getNwManager();
	UWorld* getWorld();
	static UPXConnectMain* getInstance();
protected:
	static UPXConnectMain* s_pInst;
	static bool s_stopping;
	UWorld* m_pCachedWorld;
	UPROPERTY()
	class UPXConnectNwManager* m_pNwManager;

	UPROPERTY()
	class UPXConnectRootObjects* m_pRootObjects;
};
