// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "UObject/NoExportTypes.h"
#include "PXConnectRootObjects.generated.h"

namespace AV
{
namespace UnrealSerializationHelper
{
struct UnrealActorSerializationStruct;
struct UnrealWorldSerializationStruct;
}
}

UCLASS()
class PIXERA_CONNECT_API UPXConnectRootObjects : public UObject
{
	GENERATED_BODY()

public:

	AActor* getActorWithName(const FString& objectName);
	void loadCurrentActors();
	const TMap<FString, AActor*>& getAllActors();
	void addKnownActor(AActor* pActor);
	void loadFromSerStruct(AV::UnrealSerializationHelper::UnrealWorldSerializationStruct* pWorldSerStruct);
	void loadOrCreateActorFromSerStruct(AV::UnrealSerializationHelper::UnrealActorSerializationStruct* pSerStruct);
	void setPxParentWorldDiff(unsigned long long diff);
	unsigned long long getPxParentWorldDiff();
	void sendWorldUpdate();
	void sendActorUpdate(AActor* pActor);
	float getWorldToMetersFactor();
protected:
	void newActorAdded(AActor* pActor);
	unsigned long long m_pxWorldDiff;
	TMap<FString, AActor*> m_actors;
	float m_worldToMetersFactor;
};
